
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Chart_of_accountsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const chart_of_accounts = await db.chart_of_accounts.create(
            {
                id: data.id || undefined,
        
        account_code: data.account_code
        ||
        null
            ,
            
        account_name: data.account_name
        ||
        null
            ,
            
        account_type: data.account_type
        ||
        null
            ,
            
        category: data.category
        ||
        null
            ,
            
        normal_balance: data.normal_balance
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await chart_of_accounts.setCompany( data.company || null, {
            transaction,
        });
        
        await chart_of_accounts.setParent_account( data.parent_account || null, {
            transaction,
        });
        

        

        

        return chart_of_accounts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const chart_of_accountsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                account_code: item.account_code
            ||
            null
            ,
            
                account_name: item.account_name
            ||
            null
            ,
            
                account_type: item.account_type
            ||
            null
            ,
            
                category: item.category
            ||
            null
            ,
            
                normal_balance: item.normal_balance
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const chart_of_accounts = await db.chart_of_accounts.bulkCreate(chart_of_accountsData, { transaction });

        // For each item created, replace relation files
        

        return chart_of_accounts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const chart_of_accounts = await db.chart_of_accounts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.account_code !== undefined) updatePayload.account_code = data.account_code;
        
        
        if (data.account_name !== undefined) updatePayload.account_name = data.account_name;
        
        
        if (data.account_type !== undefined) updatePayload.account_type = data.account_type;
        
        
        if (data.category !== undefined) updatePayload.category = data.category;
        
        
        if (data.normal_balance !== undefined) updatePayload.normal_balance = data.normal_balance;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await chart_of_accounts.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await chart_of_accounts.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.parent_account !== undefined) {
            await chart_of_accounts.setParent_account(
              
              data.parent_account,
              
              { transaction }
            );
        }
        

        
        

        

        return chart_of_accounts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const chart_of_accounts = await db.chart_of_accounts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of chart_of_accounts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of chart_of_accounts) {
                await record.destroy({transaction});
            }
        });


        return chart_of_accounts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const chart_of_accounts = await db.chart_of_accounts.findByPk(id, options);

        await chart_of_accounts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await chart_of_accounts.destroy({
            transaction
        });

        return chart_of_accounts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const chart_of_accounts = await db.chart_of_accounts.findOne(
            { where },
            { transaction },
        );

        if (!chart_of_accounts) {
            return chart_of_accounts;
        }

        const output = chart_of_accounts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        output.invoice_lines_revenue_account = await chart_of_accounts.getInvoice_lines_revenue_account({
            transaction
        });
        
        
        output.payments_deposit_account = await chart_of_accounts.getPayments_deposit_account({
            transaction
        });
        
        
        
        
        output.vehicle_expenses_expense_account = await chart_of_accounts.getVehicle_expenses_expense_account({
            transaction
        });
        
        output.vehicle_expenses_payment_account = await chart_of_accounts.getVehicle_expenses_payment_account({
            transaction
        });
        
        
        output.driver_expenses_expense_account = await chart_of_accounts.getDriver_expenses_expense_account({
            transaction
        });
        
        output.driver_expenses_payment_account = await chart_of_accounts.getDriver_expenses_payment_account({
            transaction
        });
        
        
        
        output.bill_lines_expense_account = await chart_of_accounts.getBill_lines_expense_account({
            transaction
        });
        
        
        output.bill_payments_payment_account = await chart_of_accounts.getBill_payments_payment_account({
            transaction
        });
        
        
        output.ledger_entries_account = await chart_of_accounts.getLedger_entries_account({
            transaction
        });
        
        
        
        
        
        
        
        output.company = await chart_of_accounts.getCompany({
            transaction
        });
        
        
        output.parent_account = await chart_of_accounts.getParent_account({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userCompanies = (user && user.companies?.id) || null;
        

        
        if (userCompanies) {
            if (options?.currentUser?.companiesId) {
                where.companiesId = options.currentUser.companiesId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
      },

      {
        model: db.chart_of_accounts,
        as: 'parent_account',
        
        where: filter.parent_account ? {
          [Op.or]: [
            { id: { [Op.in]: filter.parent_account.split('|').map(term => Utils.uuid(term)) } },
            {
              account_name: {
                [Op.or]: filter.parent_account.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.account_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'chart_of_accounts',
                        'account_code',
                        filter.account_code,
                    ),
                };
            }
            
            if (filter.account_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'chart_of_accounts',
                        'account_name',
                        filter.account_name,
                    ),
                };
            }
            
            if (filter.category) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'chart_of_accounts',
                        'category',
                        filter.category,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.account_type) {
                where = {
                    ...where,
                account_type: filter.account_type,
            };
            }
            
            if (filter.normal_balance) {
                where = {
                    ...where,
                normal_balance: filter.normal_balance,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.company) {
        const listItems = filter.company.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          companyId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.companiesId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.chart_of_accounts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'chart_of_accounts',
                        'account_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.chart_of_accounts.findAll({
            attributes: [ 'id', 'account_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['account_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.account_name,
        }));
    }

    
};

